//============================================================================
//	aisa45w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1998/11/09
//
//============================================================================
#include <windows.h>
#include <tchar.h>
#include "aisa45w.h"	// aISA-A45

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
static BOOL Aisa45wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL ߰Ċ֐ڽ̊i[ϐ
static FARPROC pAisa45GetVersion = NULL;
static FARPROC pAisa45Create = NULL;
static FARPROC pAisa45Close = NULL;
static FARPROC pAisa45GetResource = NULL;
static FARPROC pAisa45InPort = NULL;
static FARPROC pAisa45GetLastError = NULL;
static FARPROC pAisa45SetMode = NULL;
static FARPROC pAisa45StartSampling = NULL;
static FARPROC pAisa45StopSampling = NULL;
static FARPROC pAisa45GetSamplingStatus = NULL;
static FARPROC pAisa45GetData = NULL;

//============================================================================
// 	  aisa45.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(AISA45_DLL_NAME);
		if (hDLL != NULL){
			Result = Aisa45wGetDllExportFunc();
			if (TRUE != Result)
				Aisa45wDllClose();	// DLL֐擾ɎŝDLL۰
		}
	}
	return Result;
}
//============================================================================
// 	  aisa45.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
//============================================================================
// 	  aISA-A45 DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	return (*pAisa45GetVersion)(pdwDllVersion, pdwDriverVersion);
}
//============================================================================
// 	  aISA-A45̔Cӂ޲̎gp錾
// 	  pwLogSlot	gp޲̘_ۯĔԍi[߲
//		  hwnd		ײނoүނ󂯎鳲޳
//		  uWMBase	oү ID 
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wCreate(PWORD pwLogSlot, HWND hwnd, UINT uWMBase)
{
	return (*pAisa45Create)(pwLogSlot, hwnd, uWMBase);
}
//============================================================================
// 	  aISA-A45̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wClose(WORD wLogSlot)
{
	return (*pAisa45Close)(wLogSlot);
}
//============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wGetResource(WORD wLogSlot, PAISA45R pResInfo)
{
	return (*pAisa45GetResource)(wLogSlot, pResInfo);
}
//============================================================================
// 	  ݸޓӰސݒ
// 	  wLogSlot	ݸޓӰނݒ肷޲̘_ۯĔԍ
//		  pcmode@	ݸޓӰނi[\߲̂
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wSetMode(WORD wLogSlot, PAISA45MODE pcmode)
{
	return (*pAisa45SetMode)(wLogSlot, pcmode);
}
//============================================================================
// 	  ݸފJn
// 	  wLogSlot	ݸފJn޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wStartSampling(WORD wLogSlot)
{
	return (*pAisa45StartSampling)(wLogSlot);
}
//============================================================================
// 	  ݸޒ~
// 	  wLogSlot	ݸޒ~޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wStopSampling(WORD wLogSlot)
{
	return (*pAisa45StopSampling)(wLogSlot);
}
//============================================================================
// 	  ݸޏԎ擾
// 	  wLogSlot		ݸޏԂ擾޲̘_ۯĔԍ
//		  pcwNumData	ݸލςްi[̈ւ߲
//		  pdwStatus		ݸޏԂ̽ði[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wGetSamplingStatus(WORD wLogSlot, PDWORD pcwNumData, PDWORD pdwStatus)
{
	return (*pAisa45GetSamplingStatus)(wLogSlot, pcwNumData, pdwStatus);
}
//============================================================================
// 	  ݸް擾
// 	  wLogSlot		ݸް擾޲̘_ۯĔԍ
// 		  cwNumData		ǂݏoݸް
//		  pwData		ݸްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wGetData(WORD wLogSlot, DWORD cwNumData, PWORD pwData)
{
	return (*pAisa45GetData)(wLogSlot, cwNumData, pwData);
}
//============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//		  pbInValue ްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Aisa45wInPort(WORD wLogSlot, PBYTE pbInValue)
{
	return (*pAisa45InPort)(wLogSlot, pbInValue);
}
//============================================================================
// 	  aISA-A45̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
DWORD Aisa45wGetLastError(WORD wLogSlot)
{
	if (NULL == hDLL) return AISA45_ERR_WRAPDLL;
	else return (*pAisa45GetLastError)(wLogSlot);
}
//--------------------------------------------------------------------------*/
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Aisa45wGetDllExportFunc()
{
	// Aisa45GetVersion ̱ڽ擾
	pAisa45GetVersion = GetProcAddress(hDLL, _T("Aisa45GetVersion"));
	if (pAisa45GetVersion == NULL)
		return FALSE;

	// Aisa45Create ̱ڽ擾
	pAisa45Create = GetProcAddress(hDLL, _T("Aisa45Create"));
	if (pAisa45Create == NULL)
		return FALSE;

	// Aisa45Close ̱ڽ擾
	pAisa45Close = GetProcAddress(hDLL, _T("Aisa45Close"));
	if (pAisa45Close == NULL)
		return FALSE;

	// Aisa45GetResource ̱ڽ擾
	pAisa45GetResource = GetProcAddress(hDLL, _T("Aisa45GetResource"));
	if (pAisa45GetResource == NULL)
		return FALSE;

	// Aisa45InPort ̱ڽ擾
	pAisa45InPort = GetProcAddress(hDLL, _T("Aisa45InPort"));
	if (pAisa45InPort == NULL)
		return FALSE;

	// Aisa45GetLastError ̱ڽ擾
	pAisa45GetLastError = GetProcAddress(hDLL, _T("Aisa45GetLastError"));
	if (pAisa45GetLastError == NULL)
		return FALSE;

	// Aisa45SetMode ̱ڽ擾
	pAisa45SetMode = GetProcAddress(hDLL, _T("Aisa45SetMode"));
	if (pAisa45SetMode == NULL)
		return FALSE;

	// Aisa45StartSampling ̱ڽ擾
	pAisa45StartSampling = GetProcAddress(hDLL, _T("Aisa45StartSampling"));
	if (pAisa45StartSampling == NULL)
		return FALSE;

	// Aisa45StopSampling ̱ڽ擾
	pAisa45StopSampling = GetProcAddress(hDLL, _T("Aisa45StopSampling"));
	if (pAisa45StopSampling == NULL)
		return FALSE;

	// Aisa45GetSamplingStatus ̱ڽ擾
	pAisa45GetSamplingStatus = GetProcAddress(hDLL, _T("Aisa45GetSamplingStatus"));
	if (pAisa45GetSamplingStatus == NULL)
		return FALSE;

	// Aisa45GetData ̱ڽ擾
	pAisa45GetData = GetProcAddress(hDLL, _T("Aisa45GetData"));
	if (pAisa45GetData == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL ߰Ċ֐ڽ擾
}
